568. Maximum Vacation Days

Problem statement: 

LeetCode wants to give one of its best employees the option to travel among N cities to collect algorithm problems. But all work and no play makes Jack a dull boy, you could take vacations in some particular cities and weeks. Your job is to schedule the traveling to maximize the number of vacation days you could take, but there are certain rules and restrictions you need to follow.

Rules and restrictions:

  1. You can only travel among N cities, represented by indexes from 0 to N-1. Initially, you are in the city indexed 0 on Monday.
  2. The cities are connected by flights. The flights are represented as a N*N matrix (not necessary symmetrical), called flights representing the airline status from the city i to the city j. If there is no flight from the city i to the city j, flights[i][j] = 0; Otherwise, flights[i][j] = 1. Also, flights[i][i] = 0 for all i.
  3. You totally have K weeks (each week has 7 days) to travel. You can only take flights at most once per day and can only take flights on each week's Monday morning. Since flight time is so short, we don't consider the impact of flight time.
  4. For each city, you can only have restricted vacation days in different weeks, given an N*K matrix called days representing this relationship. For the value of days[i][j], it represents the maximum days you could take vacation in the city i in the week j.

You're given the flights matrix and days matrix, and you need to output the maximum vacation days you could take during K weeks.

Example 1:

Input:flights = [[0,1,1],[1,0,1],[1,1,0]], days = [[1,3,1],[6,0,3],[3,3,3]]
Output: 12
Explanation: 
Ans = 6 + 3 + 3 = 12.
One of the best strategies is: 1st week : fly from city 0 to city 1 on Monday, and play 6 days and work 1 day.
(Although you start at city 0, we could also fly to and start at other cities since it is Monday.) 2nd week : fly from city 1 to city 2 on Monday, and play 3 days and work 4 days. 3rd week : stay at city 2, and play 3 days and work 4 days.

Example 2:

Input:flights = [[0,0,0],[0,0,0],[0,0,0]], days = [[1,1,1],[7,7,7],[7,7,7]]
Output: 3
Explanation: 
Ans = 1 + 1 + 1 = 3.
Since there is no flights enable you to move to another city, you have to stay at city 0 for the whole 3 weeks.
For each week, you only have one day to play and six days to work.
So the maximum number of vacation days is 3.

Example 3:

Input:flights = [[0,1,1],[1,0,1],[1,1,0]], days = [[7,0,0],[0,7,0],[0,0,7]]
Output: 21
Explanation:
Ans = 7 + 7 + 7 = 21
One of the best strategies is: 1st week : stay at city 0, and play 7 days. 2nd week : fly from city 0 to city 1 on Monday, and play 7 days. 3rd week : fly from city 1 to city 2 on Monday, and play 7 days.

Note:

  1. N and K are positive integers, which are in the range of [1, 100].
  2. In the matrix flights, all the values are integers in the range of [0, 1].
  3. In the matrix days, all the values are integers in the range [0, 7].
  4. You could stay at a city beyond the number of vacation days, but you should work on the extra days, which won't be counted as vacation days.
  5. If you fly from the city A to the city B and take the vacation on that day, the deduction towards vacation days will count towards the vacation days of city B in that week.
  6. We don't consider the impact of flight hours towards the calculation of vacation days.

Solutions One: DFS(TLE)

First, I deploy DFS to solve this problem, find the maximum vacation days, finally this solution is TLE, because there is no any memory for the search, no prune, a lot of duplicated work.

The code is as following, the time complexity is O(N^K) since each city has K different permutations and there are N cities:

 1 class Solution {
 2 public:
 3     // this solution is TLE since it is less pruning, but it still works
 4     // time complexity is O(N^K)
 5     // N: the number of cities
 6     // K: the number of weeks
 7     // according to the problem statment there is no need for boundary check
 8     int maxVacationDays(vector<vector<int>>& flights, vector<vector<int>>& days) {
 9         int max_days = 0;
10         max_vocation_days(flights, days, 0, 0, 0, max_days);
11         return max_days;
12     }
13 private:
14     void max_vocation_days( vector<vector<int>>& flights, 
15                             vector<vector<int>>& days, 
16                             int city_idx, 
17                             int week_idx,
18                             int cur_days,
19                             int& max_days){
20         // DFS return condition
21         if(week_idx == days[0].size()){
22             // update the final answer
23             max_days = max(max_days, cur_days);
24             return;
25         }
26         for(int i = 0; i < flights[city_idx].size(); i++){
27             // do i == city_idx check 
28             // get the optimal solution by comparing staying at the same city and traveling to another city
29             if(i == city_idx || flights[city_idx][i] == 1){
30                 max_vocation_days(flights, days, i, week_idx + 1, cur_days + days[i][week_idx], max_days);
31             }
32         }
33         return;
34     }
35 };

Solution two: Dynamic programming(AC)

DP is the best solution for this problem, time complexity is O(N*K*K), K: # of weeks, N: # of cities

  • Allocate a K* N two dimension array dp: it means in week i, the best solution in city j.
  • Initalize dp[0][0...N-1]
  • The status formula is: dp[i][j] = max(dp[week][city], dp[week - 1][i] + days[city][week]);
  • The final answer is the maximum from dp[k - 1][0...N-1]
 1 class Solution {
 2 public:
 3     int maxVacationDays(vector<vector<int>>& flights, vector<vector<int>>& days) {
 4         int city_cnt = days.size();
 5         int week_cnt = days[0].size();
 6         // DP array
 7         vector<vector<int>> dp(week_cnt, vector<int>(city_cnt, -1));
 8         // DP initialize status
 9         // O(N)
10         for(int i = 0; i < city_cnt; i++){
11             if(flights[0][i] == 1 || i == 0){
12                 dp[0][i] = days[i][0];
13             }
14         }
15         // DP , O(N*K*K)
16         // start from week 1
17         // for each city, find whic on can reach current city
18         for(int week = 1; week < week_cnt; week++){
19             for(int city = 0; city < city_cnt; city++){
20                 for(int i = 0; i < city_cnt; i++){
21                     // dp[week - 1][i] != -1: this city has been visited
22                     if(dp[week - 1][i] != -1 && (flights[i][city] == 1 || i == city)){
23                         dp[week][city] = max(dp[week][city], dp[week - 1][i] + days[city][week]);
24                     }
25                 }
26             }
27         }
28         // return the maximum value from last week
29         return *max_element(dp[week_cnt - 1].begin(), dp[week_cnt - 1].end());
30     }
31 };
原文地址:https://www.cnblogs.com/wdw828/p/6819340.html